package com.ruoyi.system.mapper;

import com.ruoyi.common.core.domain.entity.SysUser;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 用户表 数据层
 *
 * @author ruoyi
 */
public interface SysUserMapper {
    /**
     * 根据条件分页查询用户列表
     *
     * @param sysUser 用户信息
     * @return 用户信息集合信息
     */
    public List<SysUser> selectUserList(SysUser sysUser);

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    public SysUser selectUserByUserName(String userName);

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    public SysUser selectUserById(Long userId);

    /**
     * 新增用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    public int insertUser(SysUser user);

    /**
     * 修改用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    public int updateUser(SysUser user);

    /**
     * 修改用户头像
     *
     * @param userName 用户名
     * @param avatar   头像地址
     * @return 结果
     */
    public int updateUserAvatar(@Param("userName") String userName, @Param("avatar") String avatar);

    /**
     * 重置用户密码
     *
     * @param userName 用户名
     * @param password 密码
     * @return 结果
     */
    public int resetUserPwd(@Param("userName") String userName, @Param("password") String password);

    /**
     * 通过用户ID删除用户
     *
     * @param userId 用户ID
     * @return 结果
     */
    public int deleteUserById(Long userId);

    /**
     * 批量删除用户信息
     *
     * @param userIds 需要删除的用户ID
     * @return 结果
     */
    public int deleteUserByIds(Long[] userIds);

    /**
     * 校验用户名称是否唯一
     *
     * @param userName 用户名称
     * @return 结果
     */
    public int checkUserNameUnique(String userName);

    /**
     * 校验手机号码是否唯一
     *
     * @param phonenumber 手机号码
     * @return 结果
     */
    public SysUser checkPhoneUnique(String phonenumber);

    /**
     * 校验email是否唯一
     *
     * @param email 用户邮箱
     * @return 结果
     */
    public SysUser checkEmailUnique(String email);

    /**
     *  根据openid更新状态信息
     * @param sysUser   用户信息
     * @return  结果
     */
    public int updateUserRelatedNo(SysUser sysUser);

    /**
     *  根据openid 更新取消关注的用户
     * @param sysUser   用户信息
     * @return  结果
     */
    public int unsubscribeUserRelatedNo(SysUser sysUser);

    /**
     *  根据openId 查询是否已授权小程序
     * @param openId    条件
     * @return  结果
     */
    public SysUser selectUserByopenId(String openId);

    /**
     *  微信小程序根据手机号查询手机号是否存在
     * @param phonenumber   手机号
     * @return  结果
     */
    SysUser selectUserByTel(String phonenumber);

    /**
     *  更新派车数据对应的
     * @param userId    用户id
     * @return  结果
     */
    public int updateCarsDriverNamePhone(Long userId);

    /**
     *  微信小程序根据手机号查询手机号是否存在
     * @param phonenumber   手机号
     * @return  结果
     */
    SysUser warehouseSelectUserByTel(String phonenumber);
    /**
     * 凯和获取航线管理员
     */
    List<Map<String, Object>>selectUserNameFO();

    /**
     *  微信小程序根据手机号查询手机号是否存在
     * @param unionId   唯一号码
     * @return  结果
     */
    public SysUser selectUserByUnionId(String unionId);

    /**
     *  查询账户或者手机号是否存在用户表中
     * @param phonenumber   手机号
     * @return
     */
    public int selectUserByUserNameOrTel(String phonenumber);

    /**
     *  根据手机号查询用户信息
     * @param phonenumber   手机号
     * @return  结果
     */
    public SysUser selectUserByPhonenumber(String phonenumber);

    /**
     * 根据角色名称查询用户
     * @param roleName
     * @return
     */
    public List<SysUser> selectUserByRole(String roleName);
}
